package org.jastadd.ros2rag.tests;

import org.jastadd.ros2rag.compiler.Compiler;
import org.jastadd.ros2rag.compiler.options.CommandLine;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.nio.file.Paths;

import static org.junit.jupiter.api.Assertions.assertTrue;

public class RosToRagTest {

  void transform(String inputFile, String outputDir) throws CommandLine.CommandLineException {

    System.out.println(Paths.get(".").toAbsolutePath());
    assertTrue(Paths.get(inputFile).toFile().exists(), "input file does not exist");

    File outputDirFile = Paths.get(outputDir).toFile();
    if (outputDirFile.exists()) {
      assertTrue(outputDirFile.isDirectory());
      if (outputDirFile.list().length != 0) {
        System.out.println("output directory is not empty!");
      }
    } else {
      outputDirFile.mkdir();
    }

    String[] args = {
        "--outputDir=" + outputDir,
        inputFile
    };

    new Compiler(args);
  }

  @Test
  void transformMinimalExample() throws CommandLine.CommandLineException {
    transform("src/test/resources/MinimalExample.relast", "src/test/resources/out");
  }
}
